<?php

/**
 * @file
 * Module handling syntactic parse of exemple sentences.
 * Aside from providing the ui to submit a sentence to parse, this module also handle the Parser Output
 * Entity type and manage their relation to FRMG Classes and their proper display and edition.
 */


module_load_include("inc", "parser", "lib/parser");
module_load_include("inc","mgwiki","mgwiki.utils");
module_load_include("module","d3js");

define("GRAPH_REGEX",'/(<|&lt;)st\s+(.*?)(>|&gt;)(.*?)(<|&lt;)\/st(>|&gt;)/s');

/*********************************************************************/
/*                            Drupal Hooks                           */
/*********************************************************************/

/**
 * Implements hook_menu().
 * @return multitype:string multitype:string  multitype:string multitype:string   multitype:string multitype:boolean   multitype:string multitype:boolean  The  multitype:string multitype:string  Ambigous <The, string, A, Optional>
 */
function parser_menu(){
  $items['new_frmgserver_proxy'] = array(
    'title' => 'Call FRMG Server Proxy',
    'page callback' => 'parser_new_frmg_server_proxy',
    'access arguments' => array('access content'),
  );
  $items['frmgserver_proxy'] = array(
      'title' => 'Call FRMG Server Proxy',
      'page callback' => 'frmg_server_proxy',
      'access arguments' => array('access content'),
  );
  $items['frmg_main'] = array(
      'title' => 'FRMG',
      'page callback' => 'frmg_main_page',
      'access arguments' => array('access content'),
      'type' => MENU_NORMAL_ITEM,
      'menu_name' => 'main-menu',
  );
  $items['frmg_main/frmg_server'] = array(
      'title' => 'FRMG Small Parser Server',
      'page callback' => 'drupal_get_form',
      'page arguments' => array('frmg_parser_server_form'),
      'access arguments' => array('access content'),
      'type' => MENU_NORMAL_ITEM,
      'menu_name' => 'main-menu',
  );
  $items['parser/autocomplete/sentences'] = array(
      'title' => 'Autocomplete for Sentences',
      'page callback' => '_parser_sentences_autocomplete',
      'access arguments' => array(true),  //or whatever permission makes sense
      'type' => MENU_CALLBACK
  );
  $items['parser/sentences/export'] = array(
      'title' => t('Sentences export'),
      'page callback' => 'parser_sentences_export',
      'access arguments' => array("access content"),
      'type'=>MENU_CALLBACK,
  );
  $items['sentence_basket'] = array(
    'title' => t('Sentences Basket'),
    'page callback' => 'drupal_get_form',
    'page arguments' => array('parser_sentence_basket_main_form'),
    'access arguments' => array("access content"),
    'type' => MENU_NORMAL_ITEM,
  );
  $items['node/%node/acceptProposal'] = array(
    'title' => t('Promouvoir en phrase du jour'),
    'page callback' => 'drupal_get_form',
    'page arguments' => array('parser_promote_proposal_form',1),
    'access callback' => 'parser_promote_proposal_access',
    'access arguments' => array(1),
    'type' => MENU_LOCAL_TASK,//MENU_CALLBACK,//  switch if book_node_view_link doesn't link to this url
    'weight' => 9,
    //'options' => array('attributes' => array('target' => '_blank'))
  );
  $items['parser/ws/%'] = array(
    'page callback' => 'parser_ws',
    'page arguments' => array(2),
    'access arguments' => array('access content'),
    'type' => MENU_CALLBACK
  );
  return $items;
}

function parser_export_access_callback(){
  return true;
}

/**
 * Implements hook_node_delete().
 * 
 * Delete the d3js entities present on the node deleted.
 * @todo Check d3js graph reference and do not delete if it has another reference.
 */
function parser_node_delete($node){
  if($node->type == "sentence"){
    // Do not delete graphs, they are just associations
    /*$gids = array();
    if(isset($node->field_representations) && $node->field_representations != null){
      foreach($node->field_representations['und'] as $gid){
        $gids[] = $gid;
      }
    }
    if(isset($node->field_main_representation) && isset($node->field_main_representation['und'])){
      $gids[] = $node->field_main_representation['und'][0]['target_id'];
    }
    entity_delete_multiple("d3js", $gids);*/
  }else if($node->type == "wiki_page" || $node->type == "protected_page" || $node->type == "forum"){
    // Do not delete graphs, info could be retrieved from wiki page revisions
    $elt_regex = GRAPH_REGEX;
    $matches = array();
    preg_match_all($elt_regex,$node->body[$node->language][0]['value'],$matches,PREG_SET_ORDER);
    foreach($matches as $match){
      $match = _parser_generic_graph_clean_match($match);
      $params = _parser_get_generic_graph_params($match['params']);
      if(isset($params['uid'])){
        $query = db_query("SELECT gid FROM d3js WHERE uid = :uid",array(":uid"=>$params['uid']));
        $gid = $query->fetchField();
        if($gid != null){
          $entity = d3js_load($gid);
          d3js_remove_ref($entity, $node->nid);
          entity_get_controller('d3js')->save($entity);
        }
      }
    }
  }
}

/**
 * Implements hook_node_submit().
 *
 */
function parser_node_submit($node, $form, &$form_state){
  $text = $form_state['values']['body']['und'][0]['value'];
  $text = preg_replace("/<\s*script(.*?)>(.*?)<\/\s*script\s*>/", "", $text);
  parser_update_graph_removed_reference($node);
  $cb = FlexibleCallback::NewCallback('parser_create_graph',array($node->nid));
  $node->body['und'][0]['value'] = _parser_replace_generic_graph($text,$cb);
}

/**
 * Implements hook_node_presave().
 */
function parser_comment_presave($comment){
  $text = $comment->comment_body['und'][0]['value'];
  $text = preg_replace("/<\s*script(.*?)>(.*?)<\/\s*script\s*>/", "", $text);
  $cb = FlexibleCallback::NewCallback('parser_create_graph');
  $comment->comment_body['und'][0]['value'] = _parser_replace_generic_graph($text,$cb);
}

/**
 * From previous version to new version of a text content, remove graphs reference to this page if graphs were removed from page between the two versions
 * @param  [type] $oldText the previous version of the text
 * @param  [type] $newText the new version of the text
 * @param  [type] $reference the node/comment id owner of the text
 * @return [type] null
 */
function parser_update_graph_removed_reference($node){
  $previous_vid = db_query('SELECT MAX(vid) AS vid FROM {node_revision} WHERE vid < :vid AND nid = :nid', array(":vid"=>$node->vid, ":nid"=>$node->nid))->fetchField();
  $oldText;
  $newText = $node->body['und'][0]['value'];
  if($previous_vid !== false){
    $prev_rev = node_load(array('nid' => $node->nid, 'vid' => $previous_vid));
    $oldText = $prev_rev->body['und'][0]['value'];
  }else{
    return;
  }
  $elt_regex = GRAPH_REGEX;
  $graphs_old = array();
  $graphs_new = array();
  $graph_to_remove_ref = array();
  Logger::Log($oldText);
  Logger::Log($newText);
  preg_match_all($elt_regex,$oldText,$graphs_old,PREG_SET_ORDER);
  foreach ($graphs_old as $match) {
    $match = _parser_generic_graph_clean_match($match);
    $params = _parser_get_generic_graph_params($match['params']);
    if(isset($params['uid'])){
      $graph_to_remove_ref[$params['uid']] = true;
    }
  }
  preg_match_all($elt_regex,$newText,$graphs_new,PREG_SET_ORDER);
  foreach ($graphs_new as $match) {
    $match = _parser_generic_graph_clean_match($match);
    $params = _parser_get_generic_graph_params($match['params']);
    if(isset($params['uid'])){
      $graph_to_remove_ref[$params['uid']] = false;
    }
  }
  Logger::Log($graphs_old);
  Logger::Log($graphs_new);
  Logger::Log($graph_to_remove_ref);
  foreach ($graph_to_remove_ref as $uid => $toberemoved) {
    if($toberemoved){
      $entity = d3js_get_graph_from_uid($uid);
      if($entity!= null){
        d3js_remove_ref($entity,$node->nid);
        entity_get_controller('d3js')->save($entity);       
      }
    }
  }
}

/*********************************************************************/
/*                         Parser Web Service                        */
/*********************************************************************/

/**
 * Callback for parser module webservices (directly print out the result)
 * @param  {string} $service the service asked
 * @return null
 */
function parser_ws($service){
  header("Access-Control-Allow-Origin: *");
  switch($service){
    case 'getRelatedPages':

      $output = rest_helper(FRMGCM_HOST."sc/_mgwiki/_matchSignature",$_POST,'POST','txt');
      $page_sets = json_decode($output,true);
      $links = array();
      usort($page_sets,function($a,$b){return $b['weight']>$a['weight']?1:-1;});
      foreach($page_sets as $set){
        if(count($set['pages'])==0){
          continue;
        }
        $pages = node_get_attribute($set['pages'],"title");
        foreach($pages as $nid => $page){
          $links[$nid] = l($page."(".$set['weight'].")","node/".$nid,array("attributes"=>array("target"=>"_blank")));
        }
      }
      
      
      
      echo json_encode($links);
      return;
    case 'listSentences':
      parser_sentences_list();
      break;
    case 'classBlock':
      $classes = $_POST['classes'];
      $trees = $_POST['trees'];

      $treesInfo = &drupal_static(__FUNCTION__ . ':trees',array());

   
     if(!count($treesInfo)){
        $alltrees = getNodes(null,"frmg_tree");
        foreach ($alltrees as $tid) {
          $tree = node_load($tid);
          $body = $tree->body[$tree->language][0]['value'];
          $body = explode(" ", $body);
          array_shift($body);
          $treeclasses = implode(" ", $body);
          $treesInfo[$treeclasses]=$tid;
        }
      }

      foreach($trees as $treename => &$tree){
        if(isset($treesInfo[$tree])){
          $titleTree = substr($treename,0,20);
          if(strlen($treename)>20){
            $titleTree .= "...";
          }
          $tree = l($titleTree,"node/".$treesInfo[$tree],array("attributes"=>array("title"=>$treename,"target"=>"_blank")));
        }else{
          $tree = null;
        }
      }

      foreach($classes as $classname => &$class){
        $class = l($classname,"node/".getNodeID($class,'frmg_class'),array("attributes"=>array("target"=>"_blank")));

      }

      $json = json_encode(array(
          "classes"=>$classes,
          "trees"=>$trees
        ));
      echo $json;


      break;
    case 'add2basket':
      if(!isset($_POST['uid'])){
        print '{"error":true,"message":"no uid given"}';
        return;
      }
      $uid = $_POST['uid'];
      parser_sentence_basket_add($uid);
      print '{"acknowledge":true}';
      break;
    case 'proposeSentence':
      if(!isset($_POST['uid'])){
        print '{"error":true,"message":"no uid given"}';
        return;
      }
      $uid = $_POST['uid'];
      print '{"url":"'.parser_create_sentence_proposition($uid).'"}';
      break;
    default:
      break;
  }
}

/*********************************************************************/
/*                           FRMG Server                             */
/*********************************************************************/


function parser_new_frmg_server_proxy(){
  module_load_include("inc", "d3js", "js/depgraph/depgraph_formats");
  $params = array();
  $sentence = '';

  if(isset($_POST['sentence'])){
    $sentence = $_POST['sentence'];
  }else if(isset($_GET['sentence'])){
    $sentence = $_GET['sentence'];
  }
  if(empty($sentence)){
    echo '{"error":true,"message":"sentence empty!"}';
    return;
  }
  if(isset($_POST['options'])){
    $params =  $_POST['options'];
  }else if(isset($_GET['options'])){
    $params = $_GET['options'];
  }
  //Logger::Log($params,"sentence");
  
  header("Content-type: text/json");
  header("Access-Control-Allow-Origin: *");

  $frmg_options = '';
  if($params['format'] == 'depxml'){
    $frmg_options .= 'xml';
  }else if($params['format'] == 'passage'){
    $frmg_options .= 'passage xml';
  }else{
    $frmg_options .= $params['format'];
  }

  if(isset($params['frmg_options'])){
    $frmg_options .= ' '.$params['frmg_options'];  
  }
  


  $data = _parser_call_frmg_server_raw($sentence,$frmg_options);
  if(isset($data)){
    $graphdata = convertGraph($data,$params['format'],'json'); 
    $graphdataarray = json_decode($graphdata,true);
    if(isset($graphdataarray['graph']) && count($graphdataarray['graph']['words'])>0){
      echo $graphdata;
    }else{
      echo '{"error":"parser returned no result"}';
    }

    
    
  }else{
    echo '{"error":"parser returned no result"}';
  }
}

function _parser_call_frmg_server_raw($sentence,$options = ''){
  
  $original_sentence = $sentence;
  $sentence = urlencode($sentence);
  $options = trim($options);
  $ext = 'xml';
  if(false !== preg_match("/(conll|depconll)/", $options)){
    $ext = 'txt';
  }
  //Logger::Log($options);
  $url = "http://alpage.inria.fr/newparserdemo/process.".$ext."?sentence=$sentence&options=cost+utf8+".urlencode($options);
  Logger::Log($url);
  try{
    $result = file_get_contents (
        $url,
        false,
        null);
  }catch(Exception $e){
    Logger::Log($e);
    return null;    
  }
  if($result == null){
    watchdog("frmgserver", "Couldn't parse $sentence");  
  }
  
  
  $log = parser_log_sentence($original_sentence,$options,$result!=null);
  
  return $result;
}


/**
 * Call the FRMG Parser Server with Default Options
 * @param unknown $sentence
 * @param unknown $params
 * 
 * @return Ambigous <NULL, string>
 * the string content of the server response or null if an error happened
 */
function _parser_call_frmg_server($sentence,$params = ''){
  
  $original_sentence = $sentence;
  $sentence = urlencode($sentence);
  $options = (!empty($params))?(' cost ' . $params):' cost';
  try{
    $result = file_get_contents (
        "http://alpage.inria.fr/newparserdemo/process.xml?sentence=$sentence&options=utf8+xml".urlencode($options)."&schema=dep&view=txt",
        false,
        null);
  }catch(Exception $e){
    Logger::Log($e);
    return null;    
  }
  if($result == null){
    watchdog("frmgserver", "Couldn't parse $sentence");  
  }else{
    $xml = new SimpleXMLElement($result);
    if($xml->count() == 0){
      watchdog("frmgserver", "Couldn't parse $sentence");
      $result = null;
    }
  }
  
  
  $log = parser_log_sentence($original_sentence,$options,$result!=null);
  
  return $result;
}

/**
 * Callback for url access of frmgserver.
 * Print depgraph json graph of a sentence parse with frmgserver.
 */
function frmg_server_proxy(){
  module_load_include("inc", "d3js", "js/depgraph/depgraph_formats");
  $params = '';
  $sentence = '';
  if(isset($_GET['sentence'])){
    $sentence = $_GET['sentence'];
  }else{
    return;
  }
  if(isset($_GET['options'])){
    $params =  $_GET['options'];
  }
  
  
  header("Content-type: text/json");
  header("Access-Control-Allow-Origin: *");
  $data = _parser_call_frmg_server($sentence,$params);
  if($data !== null){
    echo depXML2depGraph($data);
  }else{
    echo '{"error":"parser returned no result"}';
  }
  
}

/*********************************************************************/
/*                        Sentences Objects                          */
/*********************************************************************/

/**
 * Get the canonical sentence title.
 * @param unknown $sentence
 * @param number $n
 * @return Ambigous <string, unknown>
 */
function _parser_get_sentence_title($sentence,$n = 0){
  $title = $sentence;
  if(strlen($sentence)>255){
    $title = substr($sentence,0,240) . "...";
  }
  if($n > 0){
    $title .= '[' . $n . ']';
  }
  $existingSentenceTitle = getNodeID($title,'sentence');
  if($existingSentenceTitle != null){
    $n++;
    $title = _parser_get_sentence_title($sentence,$n);
  }
  return $title;
}

/**
 * Get a link to the sentence associated with a graph
 * @param unknown $gid the id of the graph
 * @param string $title (optional) the title of the link
 * @return Ambigous <string, An> the link html string
 */
function getSentenceLink($gid,$title=null){
  $nid = getSentenceFromGID($gid);
  $title = $title?$title:'lien vers la phrase';
  return l($title,'node/'.$nid.'#'.$gid);
}

/**
 * Retrieve the sentence node from the sentence title/text.
 * Null if not found.
 * @param unknown $sentence
 * @return Ambigous <NULL, A, boolean, mixed>
 */
function _parser_get_sentence($sentence){
  $row = db_query('SELECT entity_id FROM field_data_body WHERE body_value = :sentence AND bundle = :bundle', array(':sentence' => $sentence, ':bundle' => "sentence"))->fetchField();
  $node = null;
  if($row != null){
    $node = node_load($row);
  }
  return $node;
}

/**
 * Create a new sentence with canonical title
 * @param unknown $sentence
 * @return Ambigous <An, A>
 */
function _parser_create_sentence($sentence){
  $node = new stdClass();
  $node->type = "sentence";
  $node->title = _parser_get_sentence_title($sentence);
  $node->body['und'][0]['value'] = $sentence;
  $node->body['und'][0]['format'] = 'full_html';
  $node->language = LANGUAGE_NONE;
  node_object_prepare($node);
  $node = node_submit($node);
  node_save($node);
  return $node;
}

/**
 * Remove graph reference from this sentence
 * @param unknown $revision_uid
 */
function parser_sentence_remove_graph($node,$revision_gid,$save=true){
  if(isset($node->field_main_representation['und']) || count($node->field_main_representation['und']) > 0){
    if($node->field_main_representation['und'][0]['target_id'] == $revision_gid ){
      unset($node->field_main_representation['und'][0]);
    }
  }else {
    for($i=0; isset($node->field_representations['und']) && i<count($node->field_representations['und']); $i++){
      if($node->field_representations['und'][$i]['target_id']==$revision_gid){
        unset($node->field_representations['und'][$i]);
        break;        
      }
    }
  }
  if($save){
    node_save($node);
  }
}

function parser_indexable_graphs_gather(){
  $graphs = _parser_get_all_graph_tags();
  $graphs_uniques = array();
  foreach($graphs as $nid => $graphmatch){
    foreach($graphmatch as $match){
      $match = _parser_generic_graph_clean_match($match);
      $params = _parser_get_generic_graph_params($match['params']);
      $content = $match['content'];
      $entity = d3js_get_depgraph_entity(array('content'=>$content,'params'=>$params),false,null,true);
      if(!isset($entity)){
        continue;
      }else{
        if(!isset($entity->uid)){
          Logger::Log("Error when gathering indexable graph. Entity has no uid! match("+$match[0]+")","Error");
        }else{
          //todo : allow export other type of graphs
          if(isset($graphs_uniques[$entity->uid])){
            if(array_search($nid, $graphs_uniques[$entity->uid]['relatedPages']) === false){
              $graphs_uniques[$entity->uid]['relatedPages'][] = $nid;
            }
            
          }else{
            $graphs_uniques[$entity->uid] = array("uid"=>$entity->uid,"title"=>$entity->title,"relatedPages"=>array($nid));  
          }
        }
      }

    }
    
  };
  return $graphs_uniques;
}


function parser_migrate_sentences(){
  ini_set('memory_limit', -1);
  $mgwiki_graphs = array();
  $failed_graphs = array();
  $custom_graphs = array();

  // graph on pages
  $graphs = _parser_get_all_graph_tags();
  foreach($graphs as $nid => $graphmatch){
    foreach($graphmatch as $match){
      $match = _parser_generic_graph_clean_match($match);
      $params = _parser_get_generic_graph_params($match['params']);
      $content = $match['content'];
      $entity = d3js_get_depgraph_entity(array('content'=>$content,'params'=>$params),false,null,true);
      if(!isset($entity)){
        $failed_graphs[] = $match[0];
        continue;
      }else{
        if(!isset($entity->uid)){
          Logger::Log("Error when gathering indexable graph. Entity has no uid! match("+$match[0]+")","Error");
        }else{
          if(isset($mgwiki_graphs[$entity->uid])){
            Logger::Log("Error mutlitple graph on same uid (".$entity->uid.")");
          }
          if($entity->type!='mgwiki_generic_depgraph')
          unset($entity->data) ;
          $mgwiki_graphs[$entity->uid] = $entity; 
        }
      }

    }
    
  }

  // graph on sentences
  $sids = getNodes(null,"sentence");
  foreach ($sids as $sid){
    $node = node_load($sid);
    
    
    
    if(isset($node->field_main_representation['und']) || count($node->field_main_representation['und']) > 0){
      $gid = $node->field_main_representation['und'][0]['target_id'];
      $entity = d3js_load($gid);
      
      if(!isset($entity)){
        continue;
      }else{
        if(!isset($entity->uid)){
          Logger::Log("Error when gathering indexable graph. Entity has no uid! match("+$gid+")","Error");
        }else{
          if(isset($mgwiki_graphs[$entity->uid]) && $mgwiki_graphs[$entity->uid]->gid != $entity->gid){
            Logger::Log("Error mutlitple graph on same uid (".$entity->uid.")");
          }
          if($entity->type!='mgwiki_generic_depgraph')
          unset($entity->data) ;
          $mgwiki_graphs[$entity->uid] = $entity; 
        }
      }
    }
    
    if(isset($node->field_representations['und']) && count($node->field_representations['und'])>0){
      foreach($node->field_representations['und'] as $graph){
        $gid = $node->field_main_representation['und'][0]['target_id'];
        $entity = d3js_load($gid);
        if(!isset($entity)){
          continue;
        }else{
          if(!isset($entity->uid)){
            Logger::Log("Error when gathering indexable graph. Entity has no uid! match("+$gid+")","Error");
          }else{
            if(isset($mgwiki_graphs[$entity->uid]) && $mgwiki_graphs[$entity->uid]->gid != $entity->gid){
              Logger::Log("Error mutlitple graph on same uid (".$entity->uid.")");
            }
            if($entity->type!='mgwiki_generic_depgraph')
            unset($entity->data) ;
            $mgwiki_graphs[$entity->uid] = $entity; 
          }
        }
      }
    }
    unset($node);
  }



  //Logger::Log($mgwiki_graphs);
  //Logger::Log($failed_graphs);
  foreach($mgwiki_graphs as $graph){
    d3js_get_gnid_from_uid($graph->uid);
    if($graph->type == 'mgwiki_generic_depgraph'){
      $custom_graphs[] = $graph;
    }
  }

  Logger::Log($custom_graphs);
  Logger::Log(count($custom_graphs));

  Logger::SaveFile($mgwiki_graphs,"graphs_export");
  variable_del("migrate_sentence_status");
}

/**
 * Export sentences information
 * @todo optimiser l'export
 */
function parser_sentences_export(){
  header("Content-type: text/xml");
  $sids = getNodes(null,"sentence");
  $xml = new SimpleXMLElement("<sentences></sentences>");
  $xml->addAttribute("count",count($sids));
  $node = null;
  foreach ($sids as $sid){
    $node = node_load($sid);
    $sentence = $xml->addChild("sentence");
    $sentence->addAttribute("id",$sid);
    $sentence->addAttribute("title",strip_tags($node->body['und'][0]['value']));
    
    
    if(isset($node->field_main_representation['und']) || count($node->field_main_representation['und']) > 0){
      $gid = $node->field_main_representation['und'][0]['target_id'];
      $entity = d3js_load($gid);
      
      $graphxml = null;
      if(isset($entity) && isset($entity->data)){
        $graphxml = new SimpleXMLElement($entity->data);
      }else{
        Logger::Log("graph missing in sentence $sid");
      }
      
      if(isset($graphxml)){
        $graphMatch = array();
        if(isset($graphxml['highlighting']) && !empty($graphxml['highlighting'])){
          $graphMatch = d3js_frmg_highlightings2matchingRule($graphxml);
        }else if($entity->type == 'mgwiki_generic_depgraph'){
          $format = (string) $graphxml['format'];
          $json = json_decode(d3js_convert_to_depgraph_format(htmlspecialchars_decode((string)$graphxml[0]),$format),true);
          $graphMatch = d3js_extract_highlightings2matchingRule($json);
        }
        if(count($graphMatch)>0){
          $rule= d3js_frmg_matchingRule2Dpath($graphMatch);//$rule = d3js_frmg_matchingRule2String($graphMatch);
          $edges = $sentence->addChild("edges",$rule);
        }
      }
    }
    
    if(isset($node->parser_output_used_classes['und']) && count($node->parser_output_used_classes['und'])>0){
      $classes = $sentence->addChild('classes');
      foreach($node->parser_output_used_classes['und'] as $class){
        $tmp = node_get_attribute($class['target_id'],"title");
        $classname = $tmp[$class['target_id']];
        $xmlclass = $classes->addChild("class",$classname);
      }
    }
    unset($node);
  }
 echo $xml->asXML();
}

function parser_sentences_list(){
  $pages = parser_indexable_graphs_gather();

  $html = json_encode($pages);
  print $html;
}


function parser_sentences_index(){
  $output = rest_helper(FRMGCM_HOST."sc/_mgwiki/_index",$_POST,'POST','txt');
  Logger::Log($output,"sentence index");
  /*
  $sids = getNodes(null,"sentence");
  $json_array = array();
  $node = null;
  foreach ($sids as $sid){
    $node = node_load($sid);
    
    if(isset($node->field_main_representation['und']) || count($node->field_main_representation['und']) > 0){
      $gid = $node->field_main_representation['und'][0]['target_id'];
      $entity = d3js_load($gid);
      if($entity->type == 'parser_output_graph' && $entity->uid){
          $json_array[$entity->uid] = $entity->uid;
      }
      
      
    }
    
    
    unset($node);
    
  }
  echo json_encode(array_values($json_array));*/
}

/*********************************************************************/
/*                          Graph Objects                            */
/*********************************************************************/

/**
 * Get html tag from infos of an d3js depgraph entity
 * @param unknown $entity
 * @return multitype:string NULL
 */
function parser_get_tag_from_infos($infos){
  $params = $infos['params'];
  $tag = '<st ';
  foreach($params as $name => $value){
    $tag .= $name . '="' . htmlspecialchars($value) .'" ';
  }
  $tag .= '>' . htmlspecialchars($infos['content']) . '</st>';
  return $tag;
}


function _parser_get_all_graph_tags(){
  $rows = db_query("SELECT entity_id, body_value, delta, language, deleted, entity_type, revision_id FROM field_data_body WHERE bundle IN ('book', 'forum','wiki_page', 'sentence_proposal','protected_page','basic_page')")->fetchAllAssoc('entity_id');
  $graphs = array();
  foreach($rows as $row){
    $elt_regex = GRAPH_REGEX;
    $matches = array();
    preg_match_all($elt_regex,$row->body_value,$matches,PREG_SET_ORDER);
    $graphs[$row->entity_id] = $matches;
  }
  return $graphs;
}

function parser_update_all_graphs_operation(&$context){
  ini_set('memory_limit', -1);
  set_time_limit(0);
  //retrying failed graphs
  if(!isset($context['sandbox']['tried_failed'])){
    $context['results'] = array("new"=>array(),"failed"=>array(),"modified"=>array());

    $graphs = _parser_get_all_graph_tags();
    foreach($graphs as $nid => $graphmatch){
      foreach($graphmatch as $match){
        $match = _parser_generic_graph_clean_match($match);
        $params = _parser_get_generic_graph_params($match['params']);
        $content = $match['content'];
        if(!isset($params['uid'])){
          $entity = parser_save_graph($params,$content,$nid);
          if(isset($entity)){
            $context['results']['new'][] = $entity->gid;
         }
        }
        if(isset($params['format']) && $params['format']=='raw'){
          $params['format'] = 'depxml';
          $params['provider'] = 'frmgserver';
          $entity = parser_save_graph($params,$content,$nid);
          if(isset($entity)){
           $context['results']['new'][] = $entity->gid;
           $infos = d3js_get_depgraph_infos($entity);
           _parser_replace_graph_tags($entity->uid,$infos['params'],$info['content']);
          }else{
            $params['format'] = 'raw';
            unset($params['provider']);
          }
        }
      }
    }
    $context['sandbox']['tried_failed'] = true;
    $context['message'] = t('Re-trying failed graphs...') ;
    $context['finished'] = 0;
    return;
  }
  // fetching every graphs associated with a sentence
  if(!isset($context['sandbox']['graphs'])){
    $mgwiki_graphs = array();
    $sids = getNodes(null,"sentence");
    foreach ($sids as $sid){
      $node = node_load($sid);
      
      
      
      if(isset($node->field_main_representation['und']) || count($node->field_main_representation['und']) > 0){
        $gid = $node->field_main_representation['und'][0]['target_id'];
        $entity = d3js_load($gid);
        
        if(!isset($entity)){
          continue;
        }else{
          if(!isset($entity->uid)){
            Logger::Log("Error when gathering indexable graph. Entity has no uid! match("+$gid+")","Error");
          }else{
            if(isset($mgwiki_graphs[$entity->uid]) && $mgwiki_graphs[$entity->uid] != $entity->gid){
              Logger::Log("Error mutlitple graph on same uid (".$entity->uid.")");
            }
            if($entity->type=='parser_output_graph'){
              $mgwiki_graphs[$entity->uid] = $entity->gid;   
            }
          }
        }
      }
      
      if(isset($node->field_representations['und']) && count($node->field_representations['und'])>0){
        foreach($node->field_representations['und'] as $graph){
          $gid = $node->field_main_representation['und'][0]['target_id'];
          $entity = d3js_load($gid);
          if(!isset($entity)){
            continue;
          }else{
            if(!isset($entity->uid)){
              Logger::Log("Error when gathering indexable graph. Entity has no uid! match("+$gid+")","Error");
            }else{
              if(isset($mgwiki_graphs[$entity->uid]) && $mgwiki_graphs[$entity->uid] != $entity->gid){
                Logger::Log("Error mutlitple graph on same uid (".$entity->uid.")");
              }
              if($entity->type=='parser_output_graph'){
                $mgwiki_graphs[$entity->uid] = $entity->gid;   
              }
            }
          }
        }
      }
      unset($node);
    }
    $context['sandbox']['progress'] = 0;
    $context['sandbox']['graphs'] = array_values($mgwiki_graphs);
    $context['sandbox']['max'] = count($context['sandbox']['graphs']);
    $context['finished'] = 0;
    $context['message'] = t('Fetching all graphs...') ;
    return;
  }

  $i = &$context['sandbox']['progress'];
  if($i<count($context['sandbox']['graphs'])){
    $gid = $context['sandbox']['graphs'][$i];
    $entity = d3js_load($gid);
    $context['message'] = t('Updating graph..."@title"', array('@title' => $entity->title)) ;
    $taginfo = d3js_get_depgraph_infos($entity);
    $copy = d3js_copy_graph($taginfo,$entity->gnid);
    if(isset($params['options'])){
      $params['options'] = d3js_frmg_get_detailedparams(new SimpleXMLElement($copy->data),$params['options']);
    }
    $entity = d3js_get_depgraph_entity($taginfo,true,$entity->gnid,false,true);
    if(!isset($entity)){
      $context['results']['failed'][]=$gid;
      d3js_delete($copy->gid);
    }else{
      $sameResult = d3js_frmg_compare($entity->data,$copy->data);
      $xml = new SimpleXMLElement($entity->data);
      if(isset($params['options'])){
        $options =  d3js_frmg_detailedparams2id($xml,$params['options']);
        if(isset($xml['options'])){
          $xml['options'] = $options;
        }else{
          $xml->addAttribute("options",$params['options']);
        }
      }
      
      if(!$sameResult){
        $context['results']['modified'][] = array($entity->uid,$copy->uid);
        if(isset($xml['highlighting'])){
          unset($xml['highlighting']);
        }
      }else{
        if(isset($xml['highlighting'])){
          $nomatches = array();
          $detailedHighlights = d3js_frmg_matchingRule2detailedHighlight(d3js_frmg_highlightings2matchingRule($xml,null,$nomatches));
          $highlightingids = d3js_frmg_detailedHighlight2id($xml,$detailedHighlights);
          $highlightingids = array_merge($highlightingids,$nomatches);
          if(count($highlightingids)==0){
            $context['results']['modified'][] = array($entity->uid,$copy->uid);
            unset($xml['highlighting']);
          }else{
            $xml['highlighting'] = implode(",", $highlightingids);
            d3js_delete($copy->gid);
          }
        }
      }
      $entity->data = $xml->asXML();
      entity_get_controller('d3js')->save($entity);
    }
  }
  $i++;
  
  if ($context['sandbox']['progress'] != $context['sandbox']['max']) {
    $context['finished'] = $context['sandbox']['progress'] / $context['sandbox']['max'];
  }
  
}

function parser_update_all_graphs_finished_form($form,&$form_state){
  $count = variable_get("update_graph_operation_count",0);
  if(!$count){
    return $form;
  }

  $logindex = $count;
  if(isset($form_state['graph_operation_log'])){
    $logindex = $form_state['graph_operation_log'];
  }

  $results = variable_get("update_graph_operation_result_".$logindex);

  drupal_set_title("Graph Update Operations Summary (".date("F j, Y, g:i a",$results['time']).")");

  $form['select_history_container'] = array(
       '#type' => 'container',
       '#attributes' => array(
           'class' => array('container-inline'),
       ),
   );

  $form['select_history_container']['select_history'] = array(
    '#type' => 'select',
    '#title' => t('Select summary'),
    '#options' => array(
    ),
    '#default_value' => $logindex-1,
    '#description' => t('Choose graph update operations summary log.'),
  );

  for($i=1;$i<=$count;$i++){
    $log = variable_get("update_graph_operation_result_".$i);
    $form['select_history_container']['select_history']['#options'][] = date("F j, Y, g:i a",$log['time']);
  }

  $form['select_history_container']['select_history_submit'] = array(
    '#type'=>'submit',
    '#value'=>t('View log'),
    '#submit'=>array('parser_update_all_graphs_finished_form_change_log_submit')
  );


  if(isset($results['new']) && count($results['new'])>0){
    $form['new'] = array(
      '#type'=>'markup',
      '#markup'=>'<h2>'.t('Newly parsed graph (previously failing)').'</h2>'
    );
    foreach ($results['new'] as $i => $gid) {
      $entity = d3js_load($gid);
      $xml = new SimpleXMLElement($entity->data);
      $sentence = ($xml['sentence'])?htmlspecialchars_decode((string)$xml['sentence']):null;
      $form['new'.$i] = array(
        '#type'=>'markup',
        '#markup'=>l($sentence,'d3js/'.$gid.'/edit').'<br>'
        );
    }
  }

  if(isset($results['failed']) && count($results['failed'])>0){
    $form['failed'] = array(
      '#type'=>'markup',
      '#markup'=>'<h2>'.t('Newly failed parsed graph (previously succeeding)').'</h2>'
    );
    foreach ($results['failed'] as $i => $gid) {
      $view = d3js_depgraph_view(d3js_load($gid,true),array('hide-vote'=>true));
      $form['failed'.$i] = array(
        '#type'=>'markup',
        '#markup'=>$view
      );
    }
  }

  if(isset($results['modified']) && count($results['modified'])>0){
    $form['modified'] = array(
      '#type'=>'markup',
      '#markup'=>'<h2>'.t('Modified parsed graph').'</h2>'
    );
    foreach ($results['modified'] as $i => $graphs) {
      $view = parser_graph_update_compare(d3js_get_graph_from_uid($graphs[1]),d3js_get_graph_from_uid($graphs[0]));
      $form['modified'.$i] = array(
        '#type'=>'markup',
        '#markup'=>$view
      );
    }
  }

  return $form;

}

function parser_update_all_graphs_finished_form_change_log_submit($form,&$form_state){
  $form_state['rebuild'] = true;
  Logger::Log($form_state);
  $form_state['graph_operation_log'] = $form_state['values']['select_history']+1;

}

function parser_graph_update_compare($graph_entity_1,$graph_entity_2){
  $xml = new SimpleXMLElement($graph_entity_1->data);
  $sentence = ($xml['sentence'])?htmlspecialchars_decode((string)$xml['sentence']):null;

  /*$view = '<table valign="top" style="text-align:center; margin:0 10 20 10; border:1px dotted #203254">'.
    '<tr><td colspan=2>'.$sentence.'</td></tr>'.
    '<tr><td width="50%">Previous version</td><td width="50%">New Version</td></tr>'.
    '<tr><td width="50%">'.d3js_depgraph_view($graph_entity_1,array('hide-vote'=>true)).'</td><td>'.d3js_depgraph_view($graph_entity_2,array('hide-vote'=>true,"edit-mode"=>true)).'</td></tr>'.
  '</table>';*/
  $view = '<div style="width:100%; text-align:center; margin:0 10 20 10; border:1px dotted #203254">'.
    '<div style="width:100%;">'.$sentence.'</div>'.
    '<div style="display:inline-block; width:45%;">Previous version</div><div style="display:inline-block; width:45%;">New Version</div>'.
    '<div style="display:inline-block; width:45%;">'.d3js_depgraph_view($graph_entity_1,array('hide-vote'=>true)).'</div><div style="display:inline-block; width:45%;">'.d3js_depgraph_view($graph_entity_2,array('hide-vote'=>true,"edit-mode"=>true)).'</div>'.
  '</div>';
  return $view;
}

function parser_update_all_graphs_finished($success, $results, $operations){
  $results["time"] = time();
  $count = variable_get("update_graph_operation_count",0);
  $count++;
  variable_set("update_graph_operation_result_".$count,$results);
  variable_set("update_graph_operation_count",$count);
}

function parser_update_all_graphs_execute(){
  ini_set('memory_limit', -1);
  set_time_limit(0);
  $batch = array(
      'title' => t('Updating Graphs'),
      'operations' => array(
        array('parser_update_all_graphs_operation', array())
      ),
      'finished' => 'parser_update_all_graphs_finished',
      'file' => drupal_get_path('module', 'parser'),
  );
  batch_set($batch);
}


function parser_list_highlighted_graphs_form($form,&$form_state){
  $highlighted_graphs = variable_get("highlighted_graphs",array());
  if(count($highlighted_graphs)==0){
    $graphs = _parser_get_all_graph_tags();
    foreach($graphs as $nid => $graphmatch){
      $page = node_load($nid);
      $pagecontent = array();
      foreach($graphmatch as $match){
        $match = _parser_generic_graph_clean_match($match);
        $params = _parser_get_generic_graph_params($match['params']);
        $content = $match['content'];
        if(!isset($params['uid'])){
          continue;
        }
        $entity = d3js_get_graph_from_uid($params['uid']);
        $xml = new SimpleXMLElement($entity->data);
        if(isset($xml['highlighting'])){
          $highlightings = (string)$xml['highlighting'];
          if($highlightings=="n" || trim($highlightings)==""){
            unset($xml['highlighting']);
            $entity->data = $xml->asXML();
            entity_get_controller('d3js')->save($entity);
            continue;
          }
          $pagecontent[] =  $entity->gid ;
        }
      }
      if(count($pagecontent)>0){
        $highlighted_graphs[] = array("page"=>$nid,"graphs"=>$pagecontent);
      }
    }
    variable_set("highlighted_graphs",$highlighted_graphs);
  }

  $selected_page = 0;
  if(isset($form_state['selected_page'])){
    $selected_page = $form_state['selected_page']+1;
  }

  $form['select_page_container'] = array(
       '#type' => 'container',
       '#attributes' => array(
           'class' => array('container-inline'),
       ),
   );

  $form['select_page_container']['select_page'] = array(
    '#type' => 'select',
    '#title' => t('Select Page'),
    '#options' => array(
    ),
    '#default_value' => $selected_page,
    //'#description' => t('Choose graph update operations summary log.'),
  );

  for($i=1;$i<=count($highlighted_graphs);$i++){
    $page = node_load($highlighted_graphs[$i]['page']);
    $form['select_page_container']['select_page']['#options'][] = $page->title;
  }

  $form['select_page_container']['select_page_submit'] = array(
    '#type'=>'submit',
    '#value'=>t('View page graphs'),
    '#submit'=>array('parser_list_highlighted_graphs_form_submit')
  );
  
  $markup = "";
  foreach($highlighted_graphs[$selected_page]['graphs'] as $gid){
    $markup .= '<div style="display:block; width:100%;">'.d3js_depgraph_view(d3js_load($gid),array('hide-vote'=>true,"edit-mode"=>true)).'</div>';
  }

  $form['output'] = array(
    "#markup"=>$markup
  );
  return $form;
}

function parser_list_highlighted_graphs_form_submit($form,&$form_state){
  $form_state['rebuild'] = true;
  $form_state['selected_page'] = $form_state['values']['select_page'];
}


/**
 * @desc return the graphs that didn't get successfully parsed
 * @return multitype:string
 */
function parser_get_all_failed_graph(){
  $rows = db_query("SELECT entity_id, body_value, delta, language, deleted, entity_type, revision_id FROM field_data_body WHERE bundle IN ('book', 'forum', 'protected_page', 'sentence_proposal','wiki_page', 'basic_page')")->fetchAllAssoc('entity_id');
  $graphs = array();
  foreach($rows as $row){
    $elt_regex = GRAPH_REGEX;
    $matches = array();
    preg_match_all($elt_regex,$row->body_value,$matches,PREG_SET_ORDER);
    foreach($matches as $match){
      $match = _parser_generic_graph_clean_match($match);
      $params = _parser_get_generic_graph_params($match['params']);
      $content = $match['content'];
      if(!isset($params['uid'])){
        $graphs[] = array('content' => $content, 'params' => $params);
      }
    }
  }

  return $graphs;
}

function _parser_replace_graph_tags($graph_uid,$attr=null,$data=null,$replacement_uid=null){
 module_load_include('inc', 'mgwiki', 'mgwiki.utils');
  $rows = db_query("SELECT entity_id, body_value, delta, language, deleted, entity_type, revision_id FROM field_data_body WHERE bundle IN ('book', 'forum', 'sentence_proposal','protected_page', 'wiki_page', 'basic_page')")->fetchAllAssoc('entity_id');
  $cb = FlexibleCallback::NewCallback('_parser_replace_graph_tags_cb',array($graph_uid,$attr,$data,$replacement_uid));
  foreach($rows as $row){
   $elt_regex = GRAPH_REGEX;
   $count = 0;
   $newbody = preg_replace_callback($elt_regex, $cb ,$row->body_value);
   if($newbody != $row->body_value){
     $revision = db_query("
         SELECT entity_id, body_value, delta, language, deleted, entity_type, revision_id 
         FROM field_revision_body 
         WHERE bundle IN ('book', 'sentence_proposal','protected_page','forum','wiki_page', 'basic_page')
         AND entity_id = :entity_id
         AND delta = :delta
         AND language = :language
         AND deleted = :deleted
         AND entity_type = :entity_type
         AND revision_id = :revision_id",
         array(
             ':entity_id' => $row->entity_id,
             ':delta' => $row->delta,
             ':language' => $row->language,
             ':deleted' => $row->deleted,
             ':entity_type' => $row->entity_type,
             ':revision_id' => $row->revision_id             
             )
     )->fetchAssoc();
     if($revision){
       $revision['body_value'] = $newbody;
       drupal_write_record('field_revision_body', $revision, array('entity_id','delta','language','deleted','entity_type','revision_id'));
     }
     $row->body_value = $newbody;
     drupal_write_record('field_data_body', $row, array('entity_id','delta','language','deleted','entity_type'));
     // clear the cache
     cache_clear_all('field:node:' . $row->entity_id,'cache_field',TRUE);
   }
  }
}



function _parser_replace_graph_tags_cb($arguments){
  $match = $arguments[0];
  $match = _parser_generic_graph_clean_match($match);
  $params = _parser_get_generic_graph_params($match['params']);
  $content = $match['content'];
  $newdata = htmlspecialchars($arguments[1][2]);
  $newparams = $arguments[1][1];
  if(isset($params['uid']) && $params['uid'] == $arguments[1][0]){
    if(isset($arguments[1][3])){
      Logger::Log("graph revision tag replaced");
      $newparams['uid'] =$arguments[1][3]; 
    }
    $newtag = parser_get_tag_from_infos(array('content'=>$newdata,'params'=>$newparams));
    Logger::Log("Replacing tag ".$arguments[0][0]." with ".$newtag);
    return $newtag;
  }
  else{
    return $arguments[0][0];
  }
}

function _parser_get_graph_from_provider($provider,$data,&$params){
  $provider = trim(strtolower($provider));
  if($provider == 'frmgserver'){
    $options = isset($params['options'])?$params['options']:null;
    $xml = _parser_call_frmg_server($data,$options);
    if($xml == null){
      return null;
    }
    return $xml;
  }else{
    return null;
  }
}


/**
 * Save or Update a graph
 * @param unknown $params the parameters used to create the graph are :
 * <p>
 * - uid : the uid of the graph, can be null for a newly created graph
 * <p>
 * - format : the format of the graph (REQUIRED if no provider is set)
 * <p>  
 * - provider : the provider of the graph data (frmgserver mostly)
 * <p>
 * - title : the title of the graph
 * <p>
 * - options : misc options
 * @param unknown $content REQUIRED the content data of the graph.
 * this data is then either sent to the provider, or used by the corresponding format interpreter
 * @param string $nid_ref a node id reference to bind the graph to
 * @param string $reset if true, force the reset of the data (call to provider, recomputing of the data by format interpreters)
 * @return NULL|Ambigous <NULL, boolean, mixed>
 */
function parser_save_graph($params,$content,$nid_ref = null,$reset = false){
  $gid = null; // the gid of the graph
  // retrieve or create entity according to infos
  $entity = d3js_get_depgraph_entity(array('params'=>$params,'content'=>$content));
  if(!isset($entity)){
    return null;
  }
  //Logger::Log($entity);
  
  $infos = d3js_get_depgraph_infos($entity);
  //Logger::Log($infos);
  //Logger::Log($content);
  $revision_gid = null;
  
  if(!isset($params['title']) && isset($entity->title)){
    $params['title'] = $entity->title;
  }
  
  if(!isset($content) || trim($content)==""){
    $reset = true; // this is a copy
    $content = $infos['content'];
    $params['provider']=isset($infos['params']['provider'])?$infos['params']['provider']:null;
    $params['format']=isset($infos['params']['format'])?$infos['params']['format']:null;
  }
  
  //update
  $reset_anyway = ($infos['content'] != $content)
    || (!compare_array_values($infos['params'], $params,array('options','format','provider')));
    
  if($reset || $reset_anyway){
    Logger::Log("updating graph");
    Logger::Log('content changed');
    $refs = $entity->refs;
    $revision_gid = $entity->gid;
    //refactor : here i create new revision (when content, sentence, options changed) , not signatures
    $revision_bundle = d3js_create_new_revision(array('params'=>$params,'content'=>$content),$entity->gnid);
    if(!isset($revision_bundle['newRev']) || $revision_bundle['newRev']->data == null){
      d3js_delete($revision_bundle['oldRev']->gid);
      return null;
    }
    $entity = $revision_bundle['newRev'];
    $sameResult = d3js_frmg_compare($revision_bundle['newRev']->data,$revision_bundle['oldRev']->data);
    if($sameResult){
      d3js_delete($revision_bundle['oldRev']->gid);
    }

    $entity->refs = $refs; 
    if(!isset($entity)){
      return null;
    }
  }else {
    if(!compare_array_values($infos['params'], $params,array('viewmode'))){
      Logger::Log('viewmode changed');
      $xml = new SimpleXMLElement($entity->data);
      $xml['viewmode'] = $params['viewmode'];
      $entity->data = $xml->asXML();
    }
    if(!compare_array_values($infos['params'], $params,array('highlighting'))){
      Logger::Log('highlighting changed');
      $xml = new SimpleXMLElement($entity->data);
      $xml['highlighting'] = $params['highlighting'];
      $entity->data = $xml->asXML();
    }
    if(isset($params['title']) && !compare_array_values($infos['params'], $params,array('title'))){
      Logger::Log('title changed');
      $entity->title = $params['title'];
    }
  }

  // adding ref and finally save the entity
  d3js_add_ref($entity, $nid_ref);
  entity_get_controller('d3js')->save($entity);
  $gid = $entity->gid;
  // link and create sentence 
  module_load_include("inc", "d3js", "js/depgraph/depgraph_formats");
  $sentence;
  if(isset($params['provider'])){
    $sentence = $content;
  }else{
    $format = null;
    if(!isset($params['format'])){
      drupal_set_message('warning : custom data graph with no format defined!','warning');
      $format = $infos['format'];
    }else{
      $format = $params['format'];
    }
    //-- to improve
    if($params['format']=="raw"){
      $sentence = $content;
    }else{
      $json_data = d3js_convert_to_depgraph_format($content,$format);
      $sentence = getSentence($json_data);
    }
    //
    
  }
  $node;
  $row = db_query('SELECT entity_id FROM field_data_body WHERE body_value = :sentence AND bundle = :bundle', array(':sentence' => $sentence, ':bundle' => "sentence"))->fetchField();
  if($row == null){
    Logger::Log("creating sentence for graph");
    $node = new stdClass();
    $node->type = "sentence";
    $node->title = _parser_get_sentence_title($sentence);
    $node->body['und'][0]['value'] = $sentence;
    $node->body['und'][0]['format'] = 'full_html';
    $node->language = LANGUAGE_NONE;
    if(isset($node->field_main_representation['und'])){
      $node->field_representations['und'][] = array('target_id' => $gid);
    }else {
      $node->field_main_representation['und'][] = array('target_id' => $gid);
      $infos = Sentence::getRelatedClassesAndTrees($entity->data);
      $node->parser_output_used_trees['und'] = array();
      foreach($infos['trees'] as $tree){
        $node->parser_output_used_trees['und'][] = array('target_id' => $tree);
      }
    }
    node_object_prepare($node);
    // don't want sentence set in a book
    if(isset($node->book)){
      unset($node->book);
    }
    $node = node_submit($node);
  
  }else{
    $node = node_load($row);
    Logger::Log("assigning graph to already existing sentence");
    // remove previous version if new revision has been created
    if(isset($revision_gid)){
      parser_sentence_remove_graph($node,$revision_gid,false);
    }
    $isAlreadyMain = isset($node->field_main_representation['und']) && count($node->field_main_representation['und']) > 0 && $node->field_main_representation['und'][0]['target_id'] == $gid;
    if(!isset($node->field_main_representation['und']) || count($node->field_main_representation['und']) == 0){
      $node->field_main_representation['und'][] = array('target_id' => $gid);
      $infos = Sentence::getRelatedClassesAndTrees($entity->data);
      $node->parser_output_used_trees['und'] = array();
      foreach($infos['trees'] as $tree){
        $node->parser_output_used_trees['und'][] = array('target_id' => $tree);
      }
    }else if($isAlreadyMain && $reset){
      $node->field_main_representation['und'][0] = array('target_id' => $gid);
      $infos = Sentence::getRelatedClassesAndTrees($entity->data);
      $node->parser_output_used_trees['und'] = array();
      foreach($infos['trees'] as $tree){
        $node->parser_output_used_trees['und'][] = array('target_id' => $tree);
      }
    }else{
      if(!$isAlreadyMain && (!isset($node->field_representations['und']) || !existIn($gid, $node->field_representations['und'],"target_id"))){
        $node->field_representations['und'][] = array('target_id' => $gid);
      }
    }
  }
  node_save($node);
  return $entity;
}

function parser_create_graph($arguments){
  Logger::Log(__FUNCTION__);
  $match = $arguments[0];
  $node_ref = $arguments[1][0];
  $reset = isset($arguments[1][1])?$arguments[1][1]:false;
  $returnValue = $match[0];
  Logger::Log($match,"creating graph with params");
  $match = _parser_generic_graph_clean_match($match);
  $params = _parser_get_generic_graph_params($match['params']);
  $content = $match['content'];
  // empty tag with no uid reference => delete the tag  
  if((!isset($content) || empty($content)) && !isset($params['uid'])){
    return '';
  }
  // save the graph
  $entity = parser_save_graph($params, $content, $node_ref, $reset);
  //Logger::Log($entity->title);
  //Logger::Log($entity->data);
  // if the saving process failed (parser error mainly)
  if(!isset($entity)){
    unset($params['uid']);
    $tag = parser_get_tag_from_infos(array('params'=>$params,'content'=>$content));
    //Logger::Log($tag);
    return $tag;
    //Logger::Log('entity not found');
  }
  // retrieve info set to the entity
  $infos = d3js_get_depgraph_infos($entity);
  Logger::Log($infos,"infos of new graph");
  $tag = parser_get_tag_from_infos($infos);
  Logger::Log($tag,"tag of new graph");
  return $tag;
}

/*********************************************************************/
/*                       Sentence Filter                             */
/*********************************************************************/

/**
 *
 * @return multitype:string multitype:string  The multitype:string The  Ambigous <The, A, Optional>
 */
function parser_filter_info() {
  $filters['filter_frmg_sentence_example'] = array(
      'title' => t('Dependency Graph Sentence Tag'),
      'description' => t('<p>Every instance of the special &lt;st&gt; tag will be replaced with the graph corresponding to existing or newly created sentence example.</p>
      <p>The attribute "format" and/or "provider" must be informed.</p>'),
      'prepare callback' => '_filter_parser_prepare',
      'process callback' => '_filter_parser_process',
      'tips callback' => '_filter_parser_tips',
      'cache' => FALSE,
  );
  return $filters;
}

function _filter_parser_prepare($text, $filter){
  return $text;
}

function _filter_parser_process($text, $filter){
  return _parser_replace_generic_graph($text,'_parser_display_generic_graph_match');
}

function _filter_parser_tips($filter, $format, $long = false){
  return t('<p>Every instance of the special &lt;st&gt; tag will be replaced with the graph corresponding to existing or newly created sentence example.</p>
      <p>The attribute "format" and/or "provider" must be informed.</p>');
}

function _parser_replace_generic_graph($text,$callback = null){
  static $elt_regex = GRAPH_REGEX;
  $text = preg_replace("/&nbsp;/", " ", $text);
  $text = preg_replace("/&#13;/", " ", $text);
  $text = preg_replace("/\r/", " ", $text);
  if($callback==null){
    return $text;
  }else{
    return preg_replace_callback($elt_regex, $callback, $text);
  }
}

function _parser_display_generic_graph_match($match){
  if($match){
    $match = _parser_generic_graph_clean_match($match);
    $params = _parser_get_generic_graph_params($match['params']);
    $content = $match['content'];
    return _parser_display_generic_graph($content,$params);
  }
}

function _parser_display_generic_graph($content,$params){
  $entity = d3js_get_depgraph_entity(array('content'=>$content,'params'=>$params),false,null,true);
  if(isset($entity)){
    $view_mode = 'full';
    if(isset($params['viewmode'])){
      $view_mode = $params['viewmode'];
    }
    $view = d3js_view($entity,$view_mode);
    return $view['graph']['#markup'];
  }
  return $content;
}

function _parser_generic_graph_clean_match($match){
  $match['params'] = trim(removeUnusedHTMLTags($match[2]));
  $match['content'] = htmlspecialchars_decode(removeUnusedHTMLTags($match[4]));
  $match['content'] = preg_replace("/(&amp;#39;)|&#39;/", "'", $match['content']);
  return $match;
}


function _parser_get_generic_graph_params($st_tag){
  static $value_regex = '/([A-Za-z0-9_]*)\s*=\s*("|\'|&quot;)(.*?)\g{-2}/s';
  $matches = array();
  $st_tag = preg_replace('/\\\"/', "__DBL_QUOTE__", $st_tag);
  $st_tag  = preg_replace('/\\\'/', "__SGL_QUOTE__", $st_tag);
  preg_match_all($value_regex, $st_tag,$matches,PREG_SET_ORDER);
  $params = array();
  foreach ($matches as $match){
    $val = htmlspecialchars_decode($match[3]);
    $val = preg_replace("/__DBL_QUOTE__/",'"' , $val);
    $val  = preg_replace("/__SGL_QUOTE__/", "'", $val);
    $params[$match[1]] = $val;
  }
  return $params;
}


/*********************************************************************/
/*                    Sentence CKEditor Plugin                       */
/*********************************************************************/

function parser_ckeditor_plugins() {
  $plugins['sentence_example'] = array(
      'path' => drupal_get_path('module', 'parser') . '/js/ckeditor_plugin/sentence_example',
      'file' => 'plugin.js',
      'buttons' => array(
          'sentence_example' => array(
              'label' => t('Add Sentence'),
              'image' => drupal_get_path('module', 'parser') . '/js/ckeditor_plugin/sentence_example/icons/sentence_example.png',
          ),
      ),
  );
  
  // This plugins allow using div instead of iframe for ckeditor
  // => apply site wide css instead of ckeditor css :/
  // .. Don't remember why i needed it
  // If activated, problem with table
  /*$plugins['divarea'] = array(
      'path' => drupal_get_path('module', 'parser') . '/js/ckeditor_plugin/divarea',
      'file' => 'plugin.js',
      'enabled callback' => TRUE,
  );*/

  return $plugins;
}



/*********************************************************************/
/*                  Menu Callbacks & Special Pages                   */
/*********************************************************************/


/**
 * Returns the list of sentences in the wiki.
 * @param unknown $string
 */
function _parser_sentences_autocomplete($string){
  $matches = array();
  $result = db_select('node', 'n')
  ->fields('n', array('title'))
  ->condition('type','sentence')
  ->condition('title', '%' . db_like($string) . '%', 'LIKE')
  ->execute();
   
  // save the query to matches
  foreach ($result as $row) {
    $matches[$row->title] = check_plain($row->title);
  }
   
  // Return the result to the form in json
  drupal_json_output($matches);
}

function frmg_main_page(){
  $title = 'FRMG';
  drupal_goto('wiki/frmg');
}

/*********************************************************************/
/*                       Parser Server                               */
/*********************************************************************/

function parser_log_sentence($sentence,$options,$success){
  
  $record = array(
      'test' => $success,
      'data' => $sentence,
      'count' => 1,
      'options' => $options,
      'lastused' => time(),
      );
  
  $result = db_select('parser_sentence','p')
    ->fields('p',array('sid','test','created','count'))
    ->condition('data',$sentence)
    ->condition('options',$options)
    ->orderBy('created', 'DESC')
    ->range(0,1)
    ->execute()
    ->fetchAssoc();
  
  
  $primary_key = array();
  if(!empty($result) && $result['test'] == $success){
    $primary_key = 'sid';
    $record['sid'] = $result['sid'];
    $record['created'] = $result['created'];
    $record['count'] += $result['count'];
  }else{
    $record['created'] = time();
  }
  
  drupal_write_record('parser_sentence', $record, $primary_key);
  return $record;
}

function frmg_parser_server_form($form,&$form_state){
  $form['parser_ui'] = array(
    '#markup'=>theme('parser_ui',array("options"=>array()))
    );
  /*
  $sentence = null;
  $options = null;
  if(isset($_SESSION["frmg_small_server_result_sentence"])){
    $sentence = $_SESSION["frmg_small_server_result_sentence"];
  }
  if(isset($_SESSION["frmg_small_server_result_options"])){
    $options = $_SESSION["frmg_small_server_result_options"];
  }
  
  $form['sentence'] = array(
      '#title' => t('Enter your french sentence here :'),
      '#type' => 'textarea',
      '#default_value' => ($sentence!=null)?$sentence:'',
      '#cols' => 30,
      );
  $form['options'] = array(
      '#title' => t('Options :'),
      '#type' => 'textfield',
      '#default_value' => ($options!=null)?$options:'',
      '#description' => t('Available options are : format (depconll,conll,depxml,passage), robust, transform and exotic modes.').'<br>'.'Default no options.'
      );
  $form['submit'] =array(
      '#type' => 'submit',
      '#value' => 'Submit',
      '#suffix' => '<div id="result" style="margin-top:20px;"></div>'
      );
  if($sentence!=null){
    $options = $form['options']['#default_value'];
    if(isset($options) && !empty($options)){
      $form['result'] = array(
        '#title' => t('Result'),
        '#markup' => preg_replace("/(\n)/", "<br>", htmlspecialchars(frmg_parser_server_raw_submit($sentence,$options)))
      );
    }
    else{
      $params = _parser_get_generic_graph_params($form['options']['#default_value']);
      $params['provider'] = 'frmgserver';
      $params['edit-mode'] = true;
      $form['result'] = array(
          '#title' => t('Result'),
          '#markup' => _parser_display_generic_graph($sentence, $params)
      );
      $form_state['build_info']['args']['sentence'] = $sentence;
      $form_state['build_info']['args']['params'] = $params;
      $form['save_options'] = parser_save_new_sentence();
    }
    
    unset($_SESSION["frmg_small_server_result_sentence"]);
    unset($_SESSION["frmg_small_server_result_options"]);
    
    
    
  }*/
  return $form;
}

function frmg_parser_server_raw_submit($sentence,$options){
  $options = preg_replace("/(.*)(passage)(.*)/", "$1 passage xml $3", $options);
  $ret = _parser_call_frmg_server_raw($sentence,$options);
  return $ret;
}


function frmg_parser_server_form_submit($form,&$form_state){
  $_SESSION["frmg_small_server_result_sentence"] = trim($form_state['values']['sentence']);
  $_SESSION["frmg_small_server_result_options"] = trim($form_state['values']['options']);
  $form_state['rebuild'] = true;
}

function parser_save_new_sentence(){
  
  
  $form['save_container'] = array(
       '#type' => 'container',
       '#attributes' => array(
           'class' => array('container-inline'),
       ),
   );
  $form['save_container']['graph_tag'] = array(
      '#markup' => '<div id="parser-graph-tag"></div>'
  );
  $form['save_container']['save'] = array(
      '#type' => 'submit',
      '#value' => t('Save this sentence'),
      '#ajax' => array(
          'callback'=>'parser_ajax_cb_save_graph',
      ),
   );
  return $form;
}

function parser_ajax_cb_save_graph($form,&$form_state){
  $sentence = $form_state['build_info']['args']['sentence'];
  $params = $form_state['build_info']['args']['params'];
  $entity = parser_save_graph($params, $sentence);
  $content = $sentence . '(';
  if($entity != null){
    $content .= $entity->uid . ')';
  }else{
    $content .= ')';
  }
  $commands = array();
  $commands[] = ajax_command_html('#parser-graph-tag', $content);
  return array('#type' => 'ajax', '#commands' => $commands);
}

/*********************************************************************/
/*                       Parser Widgets/Blocks                       */
/*********************************************************************/

/**
 * Implements hook_block_info().
 */
function parser_block_info(){
  $blocks = array();
  
  $blocks['parser_server'] = array(
      'info' => t('FRMG Small Parser Server'),
      'cache' => DRUPAL_NO_CACHE,
  );
  
  $blocks['parser'] = array(
      'info' => t('Parser Main UI'),
      'cache' => DRUPAL_NO_CACHE,
   );
  
  $blocks['failed_parses'] = array(
    'info' => t('Failed sentence parses'),
    'cache' => DRUPAL_NO_CACHE    
  );
  
  return $blocks;
}

/**
 * Implements hook_block_view().
 */
function parser_block_view($block_name = ''){
  $block = array();
  if($block_name == 'parser'){
    $block['name'] = t('FRMG Parser');
    $block['content'] = theme('parser_ui',array("options"=>array("light_ui"=>true)));
  }else if($block_name == 'parser_server'){
    
    $block['name'] = t('FRMG Small Parser Server');
    $block['content'] = drupal_get_form('frmg_parser_server_form');
    
  }else if($block_name == 'failed_parses'){
    $block['name'] = t('FRMG sentence failed parses');
    $graphs = parser_get_all_failed_graph();
    $graphs_sentences = array();
    foreach($graphs as $graph){
      $graphs_sentences[] = $graph['content'];
    }
    $block['content'] = theme('item_list',array('items'=>$graphs_sentences));
  }
  
  return $block;
}





/*********************************************************************/
/*             Class Used/Tree Used Field Formatter                  */
/*********************************************************************/

function parser_field_formatter_info(){
  $formatters = array(
      'parser_class_used' => array(
          'label' => t('Class Used'),
          'field types' => array('entityreference'),
      ),
  );
  return $formatters;
}

function parser_forms($form_id,$args){
  $forms = array();
  if(substr($form_id, 0, strlen('parser_field_class_used_form')) == 'parser_field_class_used_form'){
    $forms[$form_id] = array(
        'callback' => 'parser_field_class_used_form');
  }
  return $forms;
}


function parser_field_formatter_prepare_view($entity_type, $entities, $field, $instances, $langcode, &$items, $display){
  global $user;
  $target_ids = array();

  $used_elements = array();
  $original_elements = array();
  // Collect every possible entity attached to any of the entities.
  foreach ($entities as $id => $entity) {
    $original_elements[$id] = $items[$id];
    $used_elements[$id] = array('classes' => array(),'trees' => array());
    $graph_uid = null;
    
    if(count($items[$id])){
      $items[$id][] = array('target_id' => 'separator', 'graph_uid' => null);
    }

    if(isset($entity->field_main_representation['und'])){
      $parser_output = entity_load_single('d3js', $entity->field_main_representation['und'][0]['target_id']);
      $xmldata = $parser_output->data;
      if(is_string($xmldata)){
        $xmldata = new SimpleXMLElement($xmldata);
      }
      $used_elements[$id] = Sentence::getRelatedClassesAndTrees($xmldata);
      $graph_uid = (string) $xmldata['uid'];
      foreach ($used_elements[$id]['classes'] as $used_class){
        if(!existIn($used_class, $items[$id], "target_id")){
          $items[$id][] = array('target_id'=>$used_class);
        }
      }
    }
    
    foreach ($items[$id] as $delta => $item) {
      if($item['target_id']!='separator'){
        $item['graph_uid'] = $graph_uid;
        if (isset($item['target_id'])) {
          $target_ids[] = $item['target_id'];
        }
      }
    }
    
    if(isAdmin($user)){ // prevent non admin to add class to a sentence
      $items[$id][] = array('target_id' => 'extra_field', 'graph_uid' => null);
    }
  }

  if ($target_ids) {
    $target_entities = entity_load($field['settings']['target_type'], $target_ids);
  }
  else {
    $target_entities = array();
  }
  
  // Iterate through the fieldable entities again to attach the loaded data.
  foreach ($entities as $id => $entity) {
    $rekey = FALSE;

    foreach ($items[$id] as $delta => $item) {
      // special field
      if($item['target_id'] == 'extra_field' || $item['target_id'] == 'separator'){
        $items[$id][$delta]['access'] = true; // TODO check if admin or right to set new class assignements
        continue;
      }

      // Check whether the referenced entity could be loaded and add supplement information.
      if (isset($target_entities[$item['target_id']])) {
        // adds info about the provenance of the element
        if(existIn($item['target_id'], $original_elements[$id], "target_id")){
          if(!existIn($item['target_id'], $used_elements[$id]['classes'])){
            $items[$id][$delta]['auto_missing'] = true;
          }
          $items[$id][$delta]['manual'] = true;
        }
        // Replace the instance value with the term data.
        $items[$id][$delta]['entity'] = $target_entities[$item['target_id']];
        // Check whether the user has access to the referenced entity.
        $items[$id][$delta]['access'] = entity_access('view', $field['settings']['target_type'], $target_entities[$item['target_id']]);
      }
      // Otherwise, unset the instance value, since the entity does not exist.
      else {
        unset($items[$id][$delta]);
        $rekey = TRUE;
      }
    }

    if ($rekey) {
      // Rekey the items array.
      $items[$id] = array_values($items[$id]);
    }
  }
}

function parser_field_formatter_view($entity_type, $entity, $field, $instance, $langcode, $items, $display){
  $result = array();
  $settings = $display['settings'];

  // Rebuild the items list to contain only those with access.
  foreach ($items as $key => $item) {
    if (empty($item['access'])) {
      unset($items[$key]);
    }
  }

  // TODO Use theme
  foreach ($items as $delta => $item) {
    // Protect ourselves from recursive rendering.
    static $depth = 0;
    $depth++;
    if ($depth > 20) {
      throw new EntityReferenceRecursiveRenderingException(t('Recursive rendering detected when rendering entity @entity_type(@entity_id). Aborting rendering.', array('@entity_type' => $entity_type, '@entity_id' => $item['target_id'])));
    }

    $data = array('item' => $item, 'sentence' => $entity);
    $options = array();
    $result[$delta] = drupal_get_form('parser_field_class_used_form_'.$item['target_id'],$data);
    /*$result[$delta] = array(
     '#markup' => theme('parser_used_classes', array('data' => $data, 'options' => $options))
    );*/
    $depth = 0;
  }
  return $result;
}

function parser_theme() {
  return array(
      'parser_used_classes' => array(
          'arguments' => array(
              'data' => NULL,
              'options' => NULL
          ),
          'template' => 'templates/used-class-formatter'
      ),
    'parser_ui' => array(
      'arguments' => array(
        'options' => array()
      ),
      'template' => 'templates/parser/parser'
    ),
  );
}

function parser_field_class_used_form($form,&$form_state){
  $basepath = drupal_get_path('module','parser') . "/templates/";
  drupal_add_css($basepath . "used-class-formatter.css");
  drupal_add_js($basepath . "used-class-formatter.js");

  $item = $form_state['build_info']['args'][0]['item'];
  $entity = $form_state['build_info']['args'][0]['sentence'];

  //$form['']
  
  $form['#attributes'] = array('style' => array('margin:0'));

  $form['container' . $item['target_id']] = array(
      '#type' => 'container',
      '#attributes' => array('class' => array('container-inline')),
  );

  $label_style;
  $action;
  $label;
  $table_style = 'margin:0;';

  if($item['target_id'] == 'extra_field' || $item['target_id'] == 'separator'){
    if($item['target_id'] == 'separator'){
      $form['container'  . $item['target_id']]['hr'] = array("#markup"=>'<hr>');
    }else{
      $form['container'  . $item['target_id']]['label'] = array(
          '#type' => 'textfield',
          '#size' => 30,
          '#autocomplete_path' => 'frmg/autocomplete/classes'
      );
      $form['container'  . $item['target_id']]['action'] = array(
          '#type' => 'submit',
          '#value' => t('Assign Class'),
          '#submit' => array('parser_used_class_assign'),
      );
    }
  }else{
    if(isAdmin()){
      if(isset($item['manual'])){
        $form['container'  . $item['target_id']]['action'] = array(
            '#type' => 'image_button',
            '#attributes' => array('title' => array(t('Remove this class')), 'class' => array('ucf-icon','ucf-remove')),
            '#submit' => array('parser_used_class_remove'),
            '#src' => $basepath . 'img/eye-minus-icon.png',
            '#value' => $item['target_id']
        );
      }else{
        $form['container'  . $item['target_id']]['action'] = array(
            '#type' => 'image_button',
            '#attributes' => array('title' => array(t('Assign this class')), 'class' => array('ucf-icon','ucf-add')),
            '#submit' => array('parser_used_class_assign'),
            '#src' => $basepath . 'img/eye-plus-icon.png',
            '#value' => $item['target_id']
        );
      }
    }
    
    $form['container'  . $item['target_id']]['label'] = array(
        '#prefix' => '<div id="class_' . $item['target_id'] . '" onmouseover="">',
        '#suffix' => '</div>',
        '#markup' => l($item['entity']->title,'node/'.$item['target_id'],array('attributes'=>array('style' => "color:inherit;"))),
    );
    if(isset($item['manual'])){
      if(isset($item['auto_missing'])){
        $form['container'  . $item['target_id']]['label']['#prefix'] = '<div id="class_' . $item['target_id'] . '" style="color:red;" onmouseover="">';
      }else{
        $form['container'  . $item['target_id']]['label']['#prefix'] = '<div id="class_' . $item['target_id'] . '" style="color:green;" onmouseover="">';
      }
    }
    
  }
  
  
  return $form;
}

function parser_used_class_assign($form,$form_state){
  Logger::Log($form_state);
  $nid = $form_state['clicked_button']['#value'];
  if($nid == 'Assign Class'){
    $class = $form_state['values']['label'];
    $nid = getNodeID($class, "frmg_class");
  }
  $node = $form_state['build_info']['args'][0]['sentence'];
  $node = node_load($node->nid);
  if($nid != null && (!isset($node->parser_output_used_classes['und']) || !existIn($nid, $node->parser_output_used_classes['und'], 'target_id'))){
    $node->parser_output_used_classes['und'][] = array('target_id' => $nid);
    node_save($node);
  }else{
    drupal_set_message("This class doesn't exist or is already assigned.","warning");
  }
}

function parser_used_class_remove($form,$form_state){
  $nid = $form_state['values']['action'];
  $node = $form_state['build_info']['args'][0]['sentence'];
  $node = node_load($node->nid);
  if($nid != null && isset($node->parser_output_used_classes['und'])){
    foreach($node->parser_output_used_classes['und'] as $i => $target){
       if($target['target_id'] == $nid){
         unset($node->parser_output_used_classes['und'][$i]);
         break;
       }     
    }
    node_save($node);
  }else{
    drupal_set_message("This class wasn't assigned.","warning");
  }
}

function parser_assign_class($form,&$form_state){
  $item = $form_state['build_info']['args'][0];
  $commands = array();
  $commands[] = ajax_command_css('#class_' . $item['target_id'], array('color'=>'red'));
  return array('#type' => 'ajax', '#commands' => $commands);
}



/*********************************************************************/
/*                        Sentence Basket                            */
/*********************************************************************/

function parser_sentence_basket_main_form($form,&$form_state){
  $basket = parser_get_sentence_basket();
  
  $result = db_select('sentence_basket_item','s')
  ->fields('s',array('uid'))
  ->condition('bid',$basket['bid'])
  ->execute()->fetchAll();
  
  
  $form['main_container']=array(
      "#type"=>"container",
      '#attributes' => array(
        'class' => array(
            'container-inline'
        ),
      ),
  );
  
  
  $form['main_container']['basket']=parser_sentence_basket_view($result);
  
  $form['main_container']['tools']=array(
      "#type"=>"container",
        '#attributes'=>array(
            'style' => array(
                'float:right;',
                'display:block;',
                'margin:10px;',
                'padding:10px;',
                'border:1px solid black;'
             )
         )
      );

  $form['main_container']['tools']['sentence_add'] = array('#type'=>'container','#attributes'=>array(
            'style' => array('display:block;')));
  $form['main_container']['tools']['sentence_add']['sentence']=array(
      '#type' => 'textfield',
      '#size' => 30,
  );
  $form['main_container']['tools']['sentence_add']['submit']=array(
      '#type' => 'submit',
      '#value' => t('Add this sentence to default basket'),
      '#submit'=> array('parser_sentence_basket_main_form_sentence_submit'),
      );
  
  $form['main_container']['tools']['uid_add'] = array('#type'=>'container','#attributes'=>array(
            'style' => array('display:block;')));
  $form['main_container']['tools']['uid_add']['uid']=array(
      '#type' => 'textfield',
      '#size' => 30,
  );
  $form['main_container']['tools']['uid_add']['submit']=array(
      '#type' => 'submit',
      '#value' => t('Add this graph reference to default basket'),
      );

  return $form;
}

function parser_sentence_basket_view($result){

  $content = array(
    '#type'=>'container',
    '#attributes' => array(
        'class' => array(
            'container-inline'
        ),
        'style' => array(
                'float:left;',
             )
      ),
  );

  

  foreach($result as $item){
    $entity = d3js_get_graph_from_uid($item->uid);
    $sentence = node_load(getSentenceFromGraphEntity($entity));
    $content['container-item-'.$item->uid] = array(
      "#type"=>"container",
      '#attributes'=>array('style' => array('display:block;'))
      
    );
    $content['container-item-'.$item->uid]['uid-'.$item->uid] = array(
      '#prefix' => '<span style="margin-right:30px;">',
      '#suffix' => '</span>',
      "#markup"=>$item->uid,
    );
    $content['container-item-'.$item->uid]['title-'.$item->uid] = array(
      '#prefix' => '<span style="margin-right:30px;">',
      '#suffix' => '</span>',
      "#markup"=>l($sentence->title,'node/'.$sentence->nid.'#'.$entity->gid),
    );
    $content['container-item-'.$item->uid]['remove-'.$item->uid] = array(
      '#name'=>'remove-'.$item->uid,
      "#type"=>'button',
      "#executes_submit_callback"=>true,
      "#submit"=>array('parser_sentence_basket_remove'),
      "#value"=>t('Remove from basket'),
      "#extra_data"=>$item->uid,
    );
  }

  return $content;
  
}


function parser_sentence_basket_remove($form,&$form_state){

  $uid = $form_state['clicked_button']["#extra_data"];
  $basket = parser_get_sentence_basket();
  db_delete('sentence_basket_item')->condition('bid',$basket['bid'])->condition('uid',$uid)->execute();
}

function parser_sentence_basket_main_form_sentence_submit($form,&$form_state){
  $sentence = $form_state['values']['sentence'];
  $params = array('title'=>$sentence,'provider'=>'frmgserver');
  $entity = parser_save_graph($params, $sentence);
  if($entity != null){
    echo parser_sentence_basket_add($entity->uid);  
  }
}

function parser_sentence_basket_main_form_submit($form,&$form_state){
  $uid = $form_state['values']['uid'];
  echo parser_sentence_basket_add($uid);
}

function parser_sentence_basket_add($uid){
  $basket = parser_get_sentence_basket();
  
  $result = db_select('sentence_basket_item','s')
  ->fields('s',array('uid'))
  ->condition('bid',$basket['bid'])
  ->execute()->fetchAll();

  // check if the sentence is already in the basket
  foreach($result as $item){
    if($uid == $item->uid){
      return ;
    }
  }

  $entity = d3js_get_graph_from_uid($uid);
  if($entity == null){
    drupal_set_message('Error when adding this reference to the basket. It seems that it doesn\'t refer to a valid sentence.','error');
    return;
  }


  $bid = $basket['bid'];
  
  $record = array(
    'bid'=>$bid,
    'uid'=>$uid
  );
  return drupal_write_record('sentence_basket_item', $record);
}

function parser_get_sentence_basket(){
  global $user;
  $result = db_select('sentence_basket','s')
  ->fields('s',array('bid','uid'))
  ->condition('uid',$user->uid)
  ->execute()
  ->fetchAssoc();
  
  
  if($result === false){
    $newbasket = array('uid'=>$user->uid,'title'=>t('Default Basket'));
    drupal_write_record('sentence_basket', $newbasket);
    $result = db_select('sentence_basket','s')
    ->fields('s',array('bid','uid'))
    ->condition('uid',$user->uid)
    ->execute()
    ->fetchAssoc();
  }
  
  return $result;
}


function parser_create_sentence_proposition($uid){
  $node = new stdClass();
  $node->type = "sentence_proposal";
  node_object_prepare($node);
  $node->title = "Phrase du jour : proposal ".$uid;
  $node->language = LANGUAGE_NONE;
  $node->body[$node->language][0]['format'] = "full_html";
  $node->body[$node->language][0]['summary'] = "";

  $entity = d3js_get_graph_from_uid($uid);
  Logger::Log($entity);
  $info = d3js_get_depgraph_infos($entity);
  Logger::Log($info);
  $tag = parser_get_tag_from_infos($info);

  $node->body[$node->language][0]['value'] = "<p></p><span class=\"sentence-example\">". $tag . "</span><br>";

  $proposalNode = getNode("Phrase du jour : Proposals","protected_page");
  $book=$proposalNode->book;
  $inbook = db_select("book","b")->fields("b")->condition("bid", $book['bid'])->execute()->fetchAll();
  $c = count($inbook) + 1;

  $node->book = array("bid" =>$book['bid'],     // use 'new' to create new top Level Book OR the NID of the Top-Level Element
      "plid" => $book['mlid'],        // use the mlid of the parent book-page
      "weight"=>-$c
  );
  node_save($node);
  _book_update_outline($node);
  global $base_path;
  return $base_path . "/node/".$node->nid."/edit";
}

function parser_promote_proposal_form($form,&$form_state,$node){
  $form['title'] = array(
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#default_value' => $node->title . " (by {$node->name})",
    '#size' => 60,
    '#maxlength' => 128,
    '#required' => TRUE,
  );

  $form['save'] = array(
    '#type' => 'submit',
    '#value' => t('Submit')
  );
  
  $form['cancel'] = array(
    '#type' => 'submit',
    '#value' => t('Cancel'),
    '#submit' => array('edit_section_form_cancel'),
  );
  $form['#node'] = $node;
  return $form;
}

function parser_promote_proposal_form_submit($form,&$form_state){
  $node = $form['#node'];
  $sentenceOfTheDay = getNode("Phrase du jour","protected_page");
  $sentenceOfTheDayBook=$sentenceOfTheDay->book;

  $proposalNode = getNode("Phrase du jour : Proposals","protected_page");
  $book=$proposalNode->book;
  db_delete("book")->condition("nid", $node->nid)->execute();
  _book_update_outline($proposalNode);

  $inbook = db_select("book","b")->fields("b")->condition("bid", $sentenceOfTheDayBook['bid'])->execute()->fetchAll();
  $c = count($inbook) + 1;

  $node->title = $form_state['values']['title'];
  $node->book = array("bid" =>$sentenceOfTheDayBook['bid'],     
      "plid" => $sentenceOfTheDayBook['mlid'],        
      "weight"=>-$c
  );
  $node->body[$node->language][0]['value'] .= "<!--break-->";
  node_save($node);
  _book_update_outline($node);
  _book_update_outline($sentenceOfTheDay);
  drupal_goto();
}

function parser_promote_proposal_access($node){
  global $user;
  $proposalNode = getNode("Phrase du jour : Proposals","protected_page");
  $book=$proposalNode->book;
  if($node->type != "sentence_proposal" || !$node->book || $node->book['bid'] != $book['bid']){
    return false;
  }
  foreach($user->roles as $role){
    $allow = (!strcmp($role, 'administrator') || !strcmp($role, 'moderator'));
    if($allow){
      return true;
    }
  }
  return false;
}
